//---------------------------------------------------------------------------
//   ,     
#include <vcl.h>
#pragma hdrstop

#include "UMain.h"
#include "UConnectDialog.h"
#include "USettings.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CGAUGES"
#pragma resource "*.dfm"

TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
//     "  "
void __fastcall TMainForm::AExitExecute(TObject *Sender)
{
Close(); //    
}
//---------------------------------------------------------------------------
//     "  "
void __fastcall TMainForm::AConnectExecute(TObject *Sender)
{
DlgConnect->Show(); //      
if(ServerSocket1->Active)ServerSocket1->Active=false;  //     ,   
Reciving=false; //      "  "
DataSize=0; //      
ATransfer->Enabled=true; //         
}
//---------------------------------------------------------------------------
//     " "
void __fastcall TMainForm::ADisconnectExecute(TObject *Sender)
{
ClientSocket1->Socket->Close(); //   
ADisconnect->Enabled=false; //   " "   
AConnect->Enabled=true; //   " "   
AServer->Enabled=true; //   "   "   ,  ,         - 
}
//---------------------------------------------------------------------------
//     "  "
void __fastcall TMainForm::ASettingsExecute(TObject *Sender)
{
DSettings->Show();  //      
DSettings->Edit1->Text=IntToStr(ServerSocket1->Port); //    Port    
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::AServerExecute(TObject *Sender)
//     "  "
{
ServerSocket1->Active=true; //       
StatusBar1->Panels->Items[1]->Text=" : ";  //      
AServer->Enabled=false; //        
AConnect->Enabled=false;
ACServer->Enabled=true;
AFileOpen->Enabled=true;
}
//---------------------------------------------------------------------------
//       - 
void __fastcall TMainForm::ServerSocket1ClientConnect(TObject *Sender,
      TCustomWinSocket *Socket)
{
StatusBar1->Panels->Items[0]->Text=": "+Socket->RemoteHost; //    
}
//---------------------------------------------------------------------------
//         
void __fastcall TMainForm::ClientSocket1Connecting(TObject *Sender,
      TCustomWinSocket *Socket)
{
StatusBar1->Panels->Items[0]->Text=" : "+Socket->RemoteHost; //    
}
//---------------------------------------------------------------------------
//         
void __fastcall TMainForm::ClientSocket1Connect(TObject *Sender,
      TCustomWinSocket *Socket)
{
StatusBar1->Panels->Items[0]->Text="  : "+Socket->RemoteHost; //    
}
//---------------------------------------------------------------------------
//       
void __fastcall TMainForm::ServerSocket1ClientDisconnect(TObject *Sender,
      TCustomWinSocket *Socket)
{
StatusBar1->Panels->Items[0]->Text=" """+Socket->RemoteHost+"""  "; //    
}
//---------------------------------------------------------------------------
//     "  "
void __fastcall TMainForm::ACServerExecute(TObject *Sender)
{
ServerSocket1->Close();  //   
StatusBar1->Panels->Items[0]->Text=" ";  //    
StatusBar1->Panels->Items[1]->Text=" :"; //     
AServer->Enabled=true; //        
ACServer->Enabled=false;
AConnect->Enabled=true;
AFileOpen->Enabled=false;
ATransfer->Enabled=false;
Label7->Visible=false;  //     
Label8->Visible=false;
}
//---------------------------------------------------------------------------
//     "  "
void __fastcall TMainForm::ClientSocket1Disconnect(TObject *Sender,
      TCustomWinSocket *Socket)
{
StatusBar1->Panels->Items[0]->Text=" "; //    
StatusBar1->Panels->Items[1]->Text=" :"; //     
ADisconnect->Enabled=false;  //        
AConnect->Enabled=true;
AServer->Enabled=true;
ATransfer->Enabled=false;
Reciving=false; //       
}
//---------------------------------------------------------------------------
//     " "
void __fastcall TMainForm::AFileOpenAccept(TObject *Sender)
{
if(AFileOpen->Dialog->FileName!="") //     
    {
      FileName=AFileOpen->Dialog->FileName; //     
      MessageDlg(" \n\""+FileName+"\"\n  ",mtInformation, TMsgDlgButtons() << mbOK, 0); //   
      Label7->Visible=true; //    
      Label8->Caption=" \""+FileName+"\"   ";  //    
      Label8->Visible=true;
    }
}
//---------------------------------------------------------------------------
//        
void __fastcall TMainForm::ClientSocket1Read(TObject *Sender,
      TCustomWinSocket *Socket)
{
  AnsiString s, sl;
  s = Socket->ReceiveText(); //       
  if (!Reciving) //      
  {
    ATransfer->Enabled=true; //   " "
    sl=s.SubString(1,s.Pos(";")-1); //          
    s.Delete(1,s.Pos(";")); //      
    DataSize = StrToInt(sl); //           
    FileName = s.SubString(s.LastDelimiter("\\")+1,s.Length()-s.LastDelimiter("\\")); //    ,      
    Data = new TFileStream(FileName,fmCreate); //       
    Reciving = true; //        
    Edit1->Text="\\\\"+Socket->RemoteHost+"\\"+s;  //        
    Label3->Caption=sl; //    
    Button1->Visible=true; //    
    Button2->Visible=false;
    CGauge1->MaxValue=DataSize;
  } else {
  //       ,     
      try   //       
    {
      Data->Write(s.data(), s.Length()); //      
      CGauge1->Progress=Data->Size; //       
      Label5->Caption=IntToStr(Data->Size); //          
      Label5->Refresh(); //       ""  
      if (Data->Size == DataSize) //        
      {
        delete Data; //      
        Data=NULL; //     
        Socket->SendText("ok"); //      ,    
        Button2->Visible = true; //    ,       
        Socket->Close(); //   
      }
    }
    catch( ... )  //               
    {
      delete Data; //      
    }
  }


}
//---------------------------------------------------------------------------
//       ""
void __fastcall TMainForm::Button1Click(TObject *Sender)
{
  ClientSocket1->Socket->SendText("ready");   //      ,     
  Button1->Visible=false; //     ,       
  Label2->Visible=true;
  Label5->Visible=true;
  Label6->Visible=true;
  CGauge1->Visible=true;
}
//---------------------------------------------------------------------------
//        
void __fastcall TMainForm::ServerSocket1ClientRead(TObject *Sender,
      TCustomWinSocket *Socket)
{
  AnsiString s = Socket->ReceiveText(); //       
  if (s == "send") //      
  {
    if(FileName!="") //     
    {
      ms = new TFileStream(FileName,fmOpenRead); //         
      ms->Position = 0; //         
      Socket->SendText(IntToStr(ms->Size)+';'+FileName); //      
    }
  }
  if (s == "ready") //      
  {
  try  //       
    {
        Label8->Font->Color=RGB(255,0,0); //      
        Label8->Caption=",   ,   ";  //   
        Socket->SendStream(ms); //   
    }
    catch ( ... ) //            
    {
    delete ms; //      
    }
  }
  if (s == "ok") //      
  {
          Label8->Font->Color=RGB(0,0,0);  //      
          Label8->Caption=" \""+FileName+"\"    "; //   
  }
}
//---------------------------------------------------------------------------
//     "    "
void __fastcall TMainForm::ATransferExecute(TObject *Sender)
{
  ClientSocket1->Socket->SendText("send"); //   
  if(Data)delete Data; //      ,  
  Data=NULL;
  Reciving = false; //    
  Label1->Visible=true;  //    
  Label3->Visible=true;
  Label4->Visible=true;
  Edit1->Visible=true;
  Button1->Visible=true;
  Label2->Visible=false;
  Label5->Visible=false;
  Label6->Visible=false;
  CGauge1->Visible=false;
  CGauge1->Progress=0;


}
//---------------------------------------------------------------------------
//        "  "
void __fastcall TMainForm::Button2Click(TObject *Sender)
{
ShellExecute(NULL,"open",FileName.c_str(),NULL,NULL,SW_MAXIMIZE); //            
}
//---------------------------------------------------------------------------

