//---------------------------------------------------------------------------

#ifndef UMainH
#define UMainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ActnList.hpp>
#include <ImgList.hpp>
#include <Menus.hpp>
#include <ScktComp.hpp>
#include <StdActns.hpp>
#include <ComCtrls.hpp>
#include <ToolWin.hpp>
#include <ExtCtrls.hpp>
#include "CGAUGES.h"
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE-managed Components
        TClientSocket *ClientSocket1;
        TServerSocket *ServerSocket1;
        TActionList *ActionList1;
        TAction *AConnect;
        TAction *ADisconnect;
        TFileOpen *AFileOpen;
        TMainMenu *MainMenu1;
        TMenuItem *Connection1;
        TMenuItem *Connect1;
        TImageList *ImageList1;
        TAction *AExit;
        TMenuItem *Disconnect1;
        TMenuItem *Files1;
        TMenuItem *Open1;
        TToolBar *ToolBar1;
        TToolButton *ToolButton1;
        TToolButton *ToolButton2;
        TToolButton *ToolButton3;
        TToolButton *ToolButton4;
        TToolButton *ToolButton5;
        TAction *AServer;
        TMenuItem *Server1;
        TMenuItem *Server2;
        TAction *ACServer;
        TMenuItem *CloseServer1;
        TAction *ATransfer;
        TAction *ASettings;
        TToolButton *ToolButton6;
        TToolButton *ToolButton7;
        TToolButton *ToolButton8;
        TToolButton *ToolButton9;
        TToolButton *ToolButton10;
        TToolButton *ToolButton11;
        TToolButton *ToolButton12;
        TMenuItem *Transfer1;
        TMenuItem *Options1;
        TMenuItem *Settings1;
        TStatusBar *StatusBar1;
        TPanel *Panel1;
        TEdit *Edit1;
        TLabel *Label1;
        TButton *Button1;
        TCGauge *CGauge1;
        TLabel *Label2;
        TLabel *Label3;
        TLabel *Label4;
        TLabel *Label5;
        TLabel *Label6;
        TButton *Button2;
        TLabel *Label7;
        TLabel *Label8;
        void __fastcall AExitExecute(TObject *Sender);
        void __fastcall AConnectExecute(TObject *Sender);
        void __fastcall ADisconnectExecute(TObject *Sender);
        void __fastcall ASettingsExecute(TObject *Sender);
        void __fastcall AServerExecute(TObject *Sender);
        void __fastcall ServerSocket1ClientConnect(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall ClientSocket1Connecting(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall ClientSocket1Connect(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall ServerSocket1ClientDisconnect(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall ACServerExecute(TObject *Sender);
        void __fastcall ClientSocket1Disconnect(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall AFileOpenAccept(TObject *Sender);
        void __fastcall ClientSocket1Read(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall Button1Click(TObject *Sender);
        void __fastcall ServerSocket1ClientRead(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall ATransferExecute(TObject *Sender);
        void __fastcall Button2Click(TObject *Sender);
private:	// User declarations
public:		// User declarations
        __fastcall TMainForm(TComponent* Owner);
        TFileStream *Data,*ms;
//        TMemoryStream *Data,*ms;
        AnsiString FileName;
        int DataSize;
        bool Reciving;
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
